Index: trunk/abdev/BasicCompiler32/MakePeHdr.cpp
===================================================================
--- trunk/abdev/BasicCompiler32/MakePeHdr.cpp	(revision 273)
+++ trunk/abdev/BasicCompiler32/MakePeHdr.cpp	(revision 276)
@@ -122,5 +122,4 @@
 	extern BOOL bDebugCompile;
 	extern DWORD ImageBase;
-	extern int obp_AllocSize;
 	extern char *basbuf;
 	extern char OutputFileName[MAX_PATH];
@@ -355,21 +354,4 @@
 
 
-
-
-	//データテーブルスケジュール
-	pobj_DataTableSchedule=new CSchedule();
-	pobj_DataTableSchedule->SetFlag(SCHEDULE_FLAG_RELOC);
-
-	//インポートテーブルスケジュール
-	pobj_ImportAddrSchedule=new CImportAddrSchedule();
-	pobj_ImportAddrSchedule->SetFlag(SCHEDULE_FLAG_RELOC);
-
-	//プロシージャポインタスケジュール
-	pobj_SubAddrSchedule=new CSubAddrSchedule();
-
-	//グローバル変数アドレススケジュール
-	pobj_GlobalVarSchedule=new CSchedule();
-	pobj_GlobalVarSchedule->SetFlag(SCHEDULE_FLAG_RELOC);
-
 	//グローバル変数の初期バッファ
 	extern BYTE *initGlobalBuf;
@@ -379,12 +361,7 @@
 	pobj_Reloc=new CReloc();
 
-	extern char *OpBuffer;
-	extern int obp;
-	obp_AllocSize=8192*2;
-	OpBuffer=(char *)malloc(obp_AllocSize);
-	obp=0;
-
 	//レキシカルスコープ情報を初期化
-	compiler.codeGenerator.lexicalScopes.Init(obp);
+	compiler.codeGenerator.lexicalScopes.Init( 0 );
+	//compiler.codeGenerator.lexicalScopes.Init( compiler.codeGenerator.GetNativeCodeSize() );
 
 
@@ -702,10 +679,9 @@
 
 			if( pUserProc->GetName() == "DllMain" ){
-				// TODO: 未完成
-				DllMain_EntryPoint=pUserProc->_beginOpAddressOld;
+				DllMain_EntryPoint = pUserProc->GetBeginOpAddress();
 			}
 
 			lpdwExportAddressTable=(DWORD *)HeapReAlloc(hHeap,0,lpdwExportAddressTable,(ExportNum+1)*sizeof(DWORD));
-			lpdwExportAddressTable[ExportNum]=pUserProc->_beginOpAddressOld;
+			lpdwExportAddressTable[ExportNum] = pUserProc->GetBeginOpAddress();
 
 			lpdwExportNamePointerTable=(DWORD *)HeapReAlloc(hHeap,0,lpdwExportNamePointerTable,(ExportNum+1)*sizeof(DWORD));
@@ -1143,76 +1119,8 @@
 
 
-	//////////////////////////////
-	// データテーブルスケジュール
-	for(i=0;i<pobj_DataTableSchedule->num;i++){
-		*((long *)(OpBuffer+pobj_DataTableSchedule->pObpValues[i]))+=ImageBase+MemPos_DataSection;
-	}
-	delete pobj_DataTableSchedule;
-
-
-	//////////////////////////////////
-	// インポートテーブルスケジュール（インポート アドレス テーブルを指し示させる）
-	for(i=0;i<pobj_ImportAddrSchedule->num;i++){
-		const DllProc *pDllProc=pobj_ImportAddrSchedule->ppdi[i];
-		*((long *)(OpBuffer+pobj_ImportAddrSchedule->pObpValues[i]))=
-			ImageBase+
-			MemPos_ImportSection+
-			LookupSize+			//ルックアップテーブル
-			HintSize+			//ヒント名（関数名）テーブル
-			pDllProc->GetLookupAddress();
-	}
-	delete pobj_ImportAddrSchedule;
-
-
-	////////////////////////////////////
-	// プロシージャポインタスケジュール
-	for(i=0;i<pobj_SubAddrSchedule->num;i++){
-		if(pobj_SubAddrSchedule->ppsi[i]->_beginOpAddressOld==0
-			&&pobj_SubAddrSchedule->ppsi[i]->_endOpAddressOld==0){
-			SetError(300,NULL,-1);
-		}
-
-		if(pobj_SubAddrSchedule->pbCall[i]){
-			*((long *)(OpBuffer+pobj_SubAddrSchedule->pObpValues[i]))=
-				pobj_SubAddrSchedule->ppsi[i]->_beginOpAddressOld-(pobj_SubAddrSchedule->pObpValues[i]+sizeof(long));
-		}
-		else{
-			*((long *)(OpBuffer+pobj_SubAddrSchedule->pObpValues[i]))=
-				pobj_SubAddrSchedule->ppsi[i]->_beginOpAddressOld+ImageBase+MemPos_CodeSection;
-		}
-	}
-	delete pobj_SubAddrSchedule;
-
-
 	if( compiler.IsDll() ){
 		//DLLの場合はリロケーション情報を生成
 		pobj_Reloc->ResetRelocBuffer();
 	}
-
-
-
-	//////////////////////////////////////
-	// グローバル変数アドレススケジュール
-	//////////////////////////////////////
-
-	/*
-	GlobalArea1 - 初期バッファあり
-	GlobalArea2 - 初期バッファなし
-	*/
-	for(i=0;i<pobj_GlobalVarSchedule->num;i++){
-		if(*((long *)(OpBuffer+pobj_GlobalVarSchedule->pObpValues[i])) & 0x80000000){
-			//初期バッファなし
-			*((long *)(OpBuffer+pobj_GlobalVarSchedule->pObpValues[i]))=
-				compiler.GetObjectModule().meta.GetGlobalVars().GetAllInitSize() +
-				(*((long *)(OpBuffer+pobj_GlobalVarSchedule->pObpValues[i])) & 0x7FFFFFFF)+
-				ImageBase+MemPos_RWSection;
-		}
-		else{
-			//初期バッファあり
-			*((long *)(OpBuffer+pobj_GlobalVarSchedule->pObpValues[i]))+=
-				ImageBase+MemPos_RWSection;
-		}
-	}
-	delete pobj_GlobalVarSchedule;
 
 
@@ -1784,8 +1692,4 @@
 	HeapDefaultFree(initGlobalBuf);
 
-	//コードバッファを解放
-	free(OpBuffer);
-	OpBuffer=0;
-
 	//リソースセクションバッファを解放
 	HeapDefaultFree(RSrcSectionBuffer);