Index: Include/Classes/System/Windows/Forms/misc.ab
===================================================================
--- Include/Classes/System/Windows/Forms/misc.ab	(revision 223)
+++ Include/Classes/System/Windows/Forms/misc.ab	(revision 282)
@@ -3,4 +3,8 @@
 #ifndef __SYSTEM_WINDOWS_FORMS_MISC_AB__
 #define __SYSTEM_WINDOWS_FORMS_MISC_AB__
+
+Namespace System
+Namespace Windows
+Namespace Forms
 
 Interface IWin32Window
@@ -19,3 +23,181 @@
 End Enum
 
+Enum Keys
+	LButton = VK_LBUTTON
+	RButton = VK_RBUTTON
+	Cancel = VK_CANCEL
+	MButton = VK_MBUTTON
+	XButton1 = VK_XBUTTON1
+	XButton2 = VK_XBUTTON2
+	Back = VK_BACK
+	Tab = VK_TAB
+	Clear = VK_CLEAR
+	Return_ = VK_RETURN
+	Shift = VK_SHIFT
+	Control = VK_CONTROL
+	Menu = VK_MENU
+	Pause = VK_PAUSE
+	Capital = VK_CAPITAL
+	KanaMode = VK_KANA
+	HangulMode = VK_HANGUL
+	JunjaMode = VK_JUNJA
+	FinalMode = VK_FINAL
+	HanjaMode = VK_HANJA
+	KanjiMode = VK_KANJI
+	Escape = VK_ESCAPE
+	IMEConvert = VK_CONVERT
+	IMENonconvert = VK_NONCONVERT
+	IMEAccept = VK_ACCEPT
+	IMEModeChange = VK_MODECHANGE
+	Space = VK_SPACE
+	PageUp = VK_PRIOR
+	PageDown = VK_NEXT
+	End_ = VK_END
+	Home = VK_HOME
+	Left = VK_LEFT
+	Up = VK_UP
+	Right = VK_RIGHT
+	Down = VK_DOWN
+	Select_ = VK_SELECT
+	Print = VK_PRINT
+	Execute = VK_EXECUTE
+	Snapshot = VK_SNAPSHOT
+	Insert = VK_INSERT
+	Delete_ = VK_DELETE
+	Help = VK_HELP
+	D0 = &h30
+	D1 = &h31
+	D2 = &h32
+	D3 = &h33
+	D4 = &h34
+	D5 = &h35
+	D6 = &h36
+	D7 = &h37
+	D8 = &h38
+	D9 = &h39
+	A = &h41
+	B = &h42
+	C = &h43
+	D = &h44
+	E = &h45
+	F = &h46
+	G = &h47
+	H = &h48
+	I = &h49
+	J = &h4a
+	K = &h4b
+	L = &h4c
+	M = &h4d
+	N = &h4e
+	O = &h4f
+	P = &h50
+	Q = &h51
+	R = &h52
+	S = &h53
+	T = &h54
+	U = &h55
+	V = &h56
+	W = &h57
+	X = &h58
+	Y = &h59
+	Z = &h5A
+	LWin = VK_LWIN
+	RWin = VK_RWIN
+	Apps = VK_APPS
+	Sleep = VK_SLEEP
+	NumPad0 = VK_NUMPAD0
+	NumPad1 = VK_NUMPAD1
+	NumPad2 = VK_NUMPAD2
+	NumPad3 = VK_NUMPAD3
+	NumPad4 = VK_NUMPAD4
+	NumPad5 = VK_NUMPAD5
+	NumPad6 = VK_NUMPAD6
+	NumPad7 = VK_NUMPAD7
+	NumPad8 = VK_NUMPAD8
+	NumPad9 = VK_NUMPAD9
+	Multiply = VK_MULTIPLY
+	Add = VK_ADD
+	Separator = VK_SEPARATOR
+	Substract = VK_SUBTRACT
+	Decimal = VK_DECIMAL
+	Divide = VK_DIVIDE
+	F1 = VK_F1
+	F2 = VK_F2
+	F3 = VK_F3
+	F4 = VK_F4
+	F5 = VK_F5
+	F6 = VK_F6
+	F7 = VK_F7
+	F8 = VK_F8
+	F9 = VK_F9
+	F10 = VK_F10
+	F11 = VK_F11
+	F12 = VK_F12
+	F13 = VK_F13
+	F14 = VK_F14
+	F15 = VK_F15
+	F16 = VK_F16
+	F17 = VK_F17
+	F18 = VK_F18
+	F19 = VK_F19
+	F20 = VK_F20
+	F21 = VK_F21
+	F22 = VK_F22
+	F23 = VK_F23
+	F24 = VK_F24
+	NumLock = VK_NUMLOCK
+	Scroll = VK_SCROLL
+	LShiftKey = VK_LSHIFT
+	RShiftKey = VK_RSHIFT
+	LControlKey = VK_LCONTROL
+	RControlKey = VK_RCONTROL
+	LMenu = VK_LMENU
+	RMenu = VK_RMENU
+	BrowserBack = VK_BROWSER_BACK
+	BrowserForward = VK_BROWSER_FORWARD
+	BrowserRefresh = VK_BROWSER_REFRESH
+	BrowserStop = VK_BROWSER_STOP
+	BrowserSearch = VK_BROWSER_SEARCH
+	BrowserFavorites = VK_BROWSER_FAVORITES
+	BrowserHome = VK_BROWSER_HOME
+	VolumeMute = VK_VOLUME_MUTE
+	VolumeDown = VK_VOLUME_DOWN
+	VolumeUp = VK_VOLUME_UP
+	MediaNextTrack = VK_MEDIA_NEXT_TRACK
+	MediaPreviousTrack = VK_MEDIA_PREV_TRACK
+	MediaStop = VK_MEDIA_STOP
+	MediaPlayPause = VK_MEDIA_PLAY_PAUSE
+	LaunchMail = VK_LAUNCH_MAIL
+	SelectMedia = VK_LAUNCH_MEDIA_SELECT
+	LaunchApplication1 = VK_LAUNCH_APP1
+	LaunchApplication2 = VK_LAUNCH_APP2
+	Oem1 = VK_OEM_1
+	Oemplus = VK_OEM_PLUS
+	Oemcomma = VK_OEM_COMMA
+	OemMinus = VK_OEM_MINUS
+	OemPeriod = VK_OEM_PERIOD
+	Oem2 = VK_OEM_2
+	Oem3 = VK_OEM_3
+	Oem4 = VK_OEM_4
+	Oem5 = VK_OEM_5
+	Oem6 = VK_OEM_6
+	Oem7 = VK_OEM_7
+	Oem8 = VK_OEM_8
+	Oem102 = VK_OEM_102
+	ProcessKey = VK_PROCESSKEY
+	Packet = VK_PACKET
+	Attn = VK_ATTN
+	Crsel = VK_CRSEL
+	Exsel = VK_EXSEL
+	EraseEof = VK_EREOF
+	Play = VK_PLAY
+	Zoom = VK_ZOOM
+	Pa1 = VK_PA1
+	OemClear = VK_OEM_CLEAR
+End Enum
+
+End Namespace 'Forms
+End Namespace 'Widnows
+End Namespace 'System
+
 #endif '__SYSTEM_WINDOWS_FORMS_MISC_AB__