Index: trunk/abdev/ProjectEditor/RadToolsAndPropertyProc.cpp
===================================================================
--- trunk/abdev/ProjectEditor/RadToolsAndPropertyProc.cpp	(revision 151)
+++ trunk/abdev/ProjectEditor/RadToolsAndPropertyProc.cpp	(revision 302)
@@ -693,5 +693,5 @@
 			switch(LOWORD(wParam)){
 				case IDC_RENAMEWINDOW:
-					if(!DialogBox(hResInst,MAKEINTRESOURCE(IDD_RAD_PROP_WINDOW_RENAME),hwnd,DlgRadProperty_Window_Rename)) return 1;
+					if(!DialogBox(hResInst,MAKEINTRESOURCE(IDD_RAD_PROP_WINDOW_RENAME),hwnd,(DLGPROC)DlgRadProperty_Window_Rename)) return 1;
 					i=GetWndNum(GetParent(GetParent(hwnd)));
 					i2=GetWndInfoNum(MdiInfo[i].path);
@@ -700,5 +700,5 @@
 					return 1;
 				case IDC_RENAMECAPTION:
-					if(!DialogBox(hResInst,MAKEINTRESOURCE(IDD_RAD_PROP_ITEM_RENAMECAPTION),hwnd,DlgRadProperty_Item_RenameCaption)) return 1;
+					if(!DialogBox(hResInst,MAKEINTRESOURCE(IDD_RAD_PROP_ITEM_RENAMECAPTION),hwnd,(DLGPROC)DlgRadProperty_Item_RenameCaption)) return 1;
 					i=GetWndNum(GetParent(GetParent(hwnd)));
 					i2=GetWndInfoNum(MdiInfo[i].path);
@@ -1066,5 +1066,5 @@
 
 				case IDC_EXSTYLE:
-					if(!DialogBox(hResInst,MAKEINTRESOURCE(IDD_RAD_PROP_WINDOW_EXSTYLE),hwnd,DlgRadProperty_Window_ExStyle)) return 1;
+					if(!DialogBox(hResInst,MAKEINTRESOURCE(IDD_RAD_PROP_WINDOW_EXSTYLE),hwnd,(DLGPROC)DlgRadProperty_Window_ExStyle)) return 1;
 					i=GetWndNum(GetParent(GetParent(hwnd)));
 					i2=GetWndInfoNum(MdiInfo[i].path);
@@ -1286,9 +1286,9 @@
 	switch(LOWORD(wParam)){
 		case IDC_RENAMEID:
-			if(!DialogBox(hResInst,MAKEINTRESOURCE(IDD_RAD_PROP_ITEM_RENAMEID),hwnd,DlgRadProperty_Item_RenameID)) return 1;
+			if(!DialogBox(hResInst,MAKEINTRESOURCE(IDD_RAD_PROP_ITEM_RENAMEID),hwnd,(DLGPROC)DlgRadProperty_Item_RenameID)) return 1;
 			SetDlgItemText(hwnd,IDC_IDNAME,ProjectInfo.pWindowInfo[WndInfoNum].pChildInfo[MdiInfo[WndNum].MdiRadInfo->SelectingItem[0]].IdName);
 			return 1;
 		case IDC_RENAMECAPTION:
-			if(!DialogBox(hResInst,MAKEINTRESOURCE(IDD_RAD_PROP_ITEM_RENAMECAPTION),hwnd,DlgRadProperty_Item_RenameCaption)) return 1;
+			if(!DialogBox(hResInst,MAKEINTRESOURCE(IDD_RAD_PROP_ITEM_RENAMECAPTION),hwnd,(DLGPROC)DlgRadProperty_Item_RenameCaption)) return 1;
 			SetDlgItemText(hwnd,IDC_CAPTION,ProjectInfo.pWindowInfo[WndInfoNum].pChildInfo[MdiInfo[WndNum].MdiRadInfo->SelectingItem[0]].caption);
 			return 1;
@@ -1611,5 +1611,5 @@
 
 				case IDC_EXSTYLE:
-					if(!DialogBox(hResInst,MAKEINTRESOURCE(IDD_RAD_PROP_ITEM_EXSTYLE),hwnd,DlgRadProperty_Item_ExStyle)) return 1;
+					if(!DialogBox(hResInst,MAKEINTRESOURCE(IDD_RAD_PROP_ITEM_EXSTYLE),hwnd,(DLGPROC)DlgRadProperty_Item_ExStyle)) return 1;
 					DrawRadWindow(i,&ProjectInfo.pWindowInfo[i2]);
 					return 1;
@@ -1891,5 +1891,5 @@
 
 				case IDC_EXSTYLE:
-					if(!DialogBox(hResInst,MAKEINTRESOURCE(IDD_RAD_PROP_ITEM_EXSTYLE),hwnd,DlgRadProperty_Item_ExStyle)) return 1;
+					if(!DialogBox(hResInst,MAKEINTRESOURCE(IDD_RAD_PROP_ITEM_EXSTYLE),hwnd,(DLGPROC)DlgRadProperty_Item_ExStyle)) return 1;
 					DrawRadWindow(i,&ProjectInfo.pWindowInfo[i2]);
 					return 1;
@@ -2137,5 +2137,5 @@
 
 				case IDC_EXSTYLE:
-					if(!DialogBox(hResInst,MAKEINTRESOURCE(IDD_RAD_PROP_ITEM_EXSTYLE),hwnd,DlgRadProperty_Item_ExStyle)) return 1;
+					if(!DialogBox(hResInst,MAKEINTRESOURCE(IDD_RAD_PROP_ITEM_EXSTYLE),hwnd,(DLGPROC)DlgRadProperty_Item_ExStyle)) return 1;
 					DrawRadWindow(i,&ProjectInfo.pWindowInfo[i2]);
 					return 1;
@@ -2437,5 +2437,5 @@
 
 				case IDC_EXSTYLE:
-					if(!DialogBox(hResInst,MAKEINTRESOURCE(IDD_RAD_PROP_ITEM_EXSTYLE),hwnd,DlgRadProperty_Item_ExStyle)) return 1;
+					if(!DialogBox(hResInst,MAKEINTRESOURCE(IDD_RAD_PROP_ITEM_EXSTYLE),hwnd,(DLGPROC)DlgRadProperty_Item_ExStyle)) return 1;
 					DrawRadWindow(i,&ProjectInfo.pWindowInfo[i2]);
 					return 1;
@@ -2570,5 +2570,5 @@
 
 				case IDC_EXSTYLE:
-					if(!DialogBox(hResInst,MAKEINTRESOURCE(IDD_RAD_PROP_ITEM_EXSTYLE),hwnd,DlgRadProperty_Item_ExStyle)) return 1;
+					if(!DialogBox(hResInst,MAKEINTRESOURCE(IDD_RAD_PROP_ITEM_EXSTYLE),hwnd,(DLGPROC)DlgRadProperty_Item_ExStyle)) return 1;
 					DrawRadWindow(i,&ProjectInfo.pWindowInfo[i2]);
 					return 1;
@@ -2966,5 +2966,5 @@
 
 				case IDC_EXSTYLE:
-					if(!DialogBox(hResInst,MAKEINTRESOURCE(IDD_RAD_PROP_ITEM_EXSTYLE),hwnd,DlgRadProperty_Item_ExStyle)) return 1;
+					if(!DialogBox(hResInst,MAKEINTRESOURCE(IDD_RAD_PROP_ITEM_EXSTYLE),hwnd,(DLGPROC)DlgRadProperty_Item_ExStyle)) return 1;
 					DrawRadWindow(i,&ProjectInfo.pWindowInfo[i2]);
 					return 1;
@@ -3237,5 +3237,5 @@
 
 				case IDC_EXSTYLE:
-					if(!DialogBox(hResInst,MAKEINTRESOURCE(IDD_RAD_PROP_ITEM_EXSTYLE),hwnd,DlgRadProperty_Item_ExStyle)) return 1;
+					if(!DialogBox(hResInst,MAKEINTRESOURCE(IDD_RAD_PROP_ITEM_EXSTYLE),hwnd,(DLGPROC)DlgRadProperty_Item_ExStyle)) return 1;
 					DrawRadWindow(i,&ProjectInfo.pWindowInfo[i2]);
 					return 1;
@@ -3506,5 +3506,5 @@
 
 				case IDC_EXSTYLE:
-					if(!DialogBox(hResInst,MAKEINTRESOURCE(IDD_RAD_PROP_ITEM_EXSTYLE),hwnd,DlgRadProperty_Item_ExStyle)) return 1;
+					if(!DialogBox(hResInst,MAKEINTRESOURCE(IDD_RAD_PROP_ITEM_EXSTYLE),hwnd,(DLGPROC)DlgRadProperty_Item_ExStyle)) return 1;
 					DrawRadWindow(i,&ProjectInfo.pWindowInfo[i2]);
 					return 1;
@@ -3588,5 +3588,5 @@
 
 				case IDC_EXSTYLE:
-					if(!DialogBox(hResInst,MAKEINTRESOURCE(IDD_RAD_PROP_ITEM_EXSTYLE),hwnd,DlgRadProperty_Item_ExStyle)) return 1;
+					if(!DialogBox(hResInst,MAKEINTRESOURCE(IDD_RAD_PROP_ITEM_EXSTYLE),hwnd,(DLGPROC)DlgRadProperty_Item_ExStyle)) return 1;
 					DrawRadWindow(i,&ProjectInfo.pWindowInfo[i2]);
 					return 1;
@@ -3818,5 +3818,5 @@
 
 				case IDC_EXSTYLE:
-					if(!DialogBox(hResInst,MAKEINTRESOURCE(IDD_RAD_PROP_ITEM_EXSTYLE),hwnd,DlgRadProperty_Item_ExStyle)) return 1;
+					if(!DialogBox(hResInst,MAKEINTRESOURCE(IDD_RAD_PROP_ITEM_EXSTYLE),hwnd,(DLGPROC)DlgRadProperty_Item_ExStyle)) return 1;
 					DrawRadWindow(i,&ProjectInfo.pWindowInfo[i2]);
 					return 1;
@@ -3900,5 +3900,5 @@
 
 				case IDC_EXSTYLE:
-					if(!DialogBox(hResInst,MAKEINTRESOURCE(IDD_RAD_PROP_ITEM_EXSTYLE),hwnd,DlgRadProperty_Item_ExStyle)) return 1;
+					if(!DialogBox(hResInst,MAKEINTRESOURCE(IDD_RAD_PROP_ITEM_EXSTYLE),hwnd,(DLGPROC)DlgRadProperty_Item_ExStyle)) return 1;
 					DrawRadWindow(i,&ProjectInfo.pWindowInfo[i2]);
 					return 1;
@@ -4029,5 +4029,5 @@
 
 				case IDC_EXSTYLE:
-					if(!DialogBox(hResInst,MAKEINTRESOURCE(IDD_RAD_PROP_ITEM_EXSTYLE),hwnd,DlgRadProperty_Item_ExStyle)) return 1;
+					if(!DialogBox(hResInst,MAKEINTRESOURCE(IDD_RAD_PROP_ITEM_EXSTYLE),hwnd,(DLGPROC)DlgRadProperty_Item_ExStyle)) return 1;
 					DrawRadWindow(i,&ProjectInfo.pWindowInfo[i2]);
 					return 1;
@@ -4179,5 +4179,5 @@
 
 				case IDC_EXSTYLE:
-					if(!DialogBox(hResInst,MAKEINTRESOURCE(IDD_RAD_PROP_ITEM_EXSTYLE),hwnd,DlgRadProperty_Item_ExStyle)) return 1;
+					if(!DialogBox(hResInst,MAKEINTRESOURCE(IDD_RAD_PROP_ITEM_EXSTYLE),hwnd,(DLGPROC)DlgRadProperty_Item_ExStyle)) return 1;
 					DrawRadWindow(i,&ProjectInfo.pWindowInfo[i2]);
 					return 1;
@@ -4388,5 +4388,5 @@
 
 				case IDC_EXSTYLE:
-					if(!DialogBox(hResInst,MAKEINTRESOURCE(IDD_RAD_PROP_ITEM_EXSTYLE),hwnd,DlgRadProperty_Item_ExStyle)) return 1;
+					if(!DialogBox(hResInst,MAKEINTRESOURCE(IDD_RAD_PROP_ITEM_EXSTYLE),hwnd,(DLGPROC)DlgRadProperty_Item_ExStyle)) return 1;
 					DrawRadWindow(i,&ProjectInfo.pWindowInfo[i2]);
 					return 1;
@@ -4561,5 +4561,5 @@
 
 				case IDC_EXSTYLE:
-					if(!DialogBox(hResInst,MAKEINTRESOURCE(IDD_RAD_PROP_ITEM_EXSTYLE),hwnd,DlgRadProperty_Item_ExStyle)) return 1;
+					if(!DialogBox(hResInst,MAKEINTRESOURCE(IDD_RAD_PROP_ITEM_EXSTYLE),hwnd,(DLGPROC)DlgRadProperty_Item_ExStyle)) return 1;
 					DrawRadWindow(i,&ProjectInfo.pWindowInfo[i2]);
 					return 1;