Index: trunk/Include/objidl.sbp
===================================================================
--- trunk/Include/objidl.sbp	(revision 300)
+++ trunk/Include/objidl.sbp	(revision 303)
@@ -13,6 +13,4 @@
 /* interface IMarshal */
 /* [uuid][object][local] */
-
-TypeDef LPMARSHAL = /* [unique] */ *IMarshal
 
 Dim IID_IMarshal = [&h00000003, 0, 0, [&hC0, 0, 0, 0, 0, 0, 0, &h46]] As IID
@@ -51,5 +49,14 @@
 End Interface
 
-' IMarshal2
+/* interface IMarshal2 */
+/* [uuid][object][local] */
+
+Dim IID_IMarshal2 = [&h000001Cf, 0, 0, [&hC0, 0, 0, 0, 0, 0, 0, &h46]] As IID
+Interface IMarshal2
+	Inherits IMarshal
+End Interface
+
+/* interface IMalloc */
+/* [uuid][object][local] */
 
 Dim IID_IMalloc = [&h00000002, 0, 0, [&hC0, 0, 0, 0, 0, 0, 0, &h46]] As IID
@@ -69,5 +76,44 @@
 End Interface
 
-' IMallocSpy
+/* interface IMallocSpy */
+/* [uuid][object][local] */
+
+Dim IID_IMallocSpy = [&h0000001d, 0, 0, [&hC0, 0, 0, 0, 0, 0, 0, &h46]] As IID
+Interface IMallocSpy
+	Inherits IUnknown
+
+	Function PreAlloc(
+		/* [in] */ cbRequest As SIZE_T) As HRESULT
+	Function PostAlloc(
+		/* [in] */ pActual As VoidPtr) As VoidPtr
+	Function PreFree(
+		/* [in] */ pRequest As VoidPtr,
+		/* [in] */ fSpyed As BOOL) As VoidPtr
+	Sub PostFree(
+		/* [in] */ fSpyed As BOOL)
+	Function PreRealloc(
+		/* [in] */ pRequest As VoidPtr,
+		/* [in] */ cbRequestt As SIZE_T,
+		/* [out] */ ByRef ppNewRequest As VoidPtr,
+		/* [in] */ fSpyed As BOOL) As HRESULT
+	Function PostRealloc(
+		/* [in] */ pActual As VoidPtr,
+		/* [in] */ fSpyed As BOOL) As VoidPtr
+	Function PreGetSize(
+		/* [in] */ pRequest As VoidPtr,
+		/* [in] */ fSpyed As BOOL) As VoidPtr
+	Function PostGetSize(
+		/* [in] */ cbActual As SIZE_T,
+		/* [in] */ fSpyed As BOOL) As HRESULT
+	Function PreDidAlloc(
+	/* [in] */ pRequest As VoidPtr,
+	/* [in] */ fSpyed As BOOL) As VoidPtr
+	Function PostDidAlloc(
+	/* [in] */ pRequest As VoidPtr,
+	/* [in] */ fSpyed As BOOL,
+	/* [in] */ fActual As Long) As Long
+	Sub PreHeapMinimize()
+	Sub PostHeapMinimize()
+End Interface
 
 ' IStdMarshalInfo
@@ -77,10 +123,9 @@
 Type MULTI_QI
 	pIID As * /*Const*/ IID
-	pItf As *IUnknown
+	pItf As IUnknown
 	hr As HRESULT
 End Type
 
 Dim IID_IMultiQI = [&h00000020, &h0000, &h0000, [&hC0, &h00, &h00, &h00, &h00, &h00, &h00, &h46]] As IID
-
 Interface IMultiQI
 	Inherits IUnknown
@@ -95,5 +140,24 @@
 ' IInternalUnknown
 
-' IEnumUnknown
+/* interface IEnumUnknown */
+/* [unique][uuid][object] */
+
+Dim IID_IEnumUnknown = [&h00000100, 0, 0, [&hC0, 0, 0, 0, 0, 0, 0, &h46]] As IID
+Interface IEnumUnknown
+	Inherits IUnknown
+
+	/* [local] */ Function Next_(
+		/* [in] */ celt As DWord,
+		/* [out] */ rgelt As *IUnknown,
+		/* [out] */ ByRef celtFetched As DWord) As HRESULT
+	Function Skip(
+		/* [in] */ celt As DWord) As HRESULT
+	Function Reset() As HRESULT
+	Function Clone(
+		/* [out] */ ByRef enumUnk As IEnumUnknown) As HRESULT
+End Interface
+
+/* interface IBindCtx */
+/* [unique][uuid][object] */
 
 Type BIND_OPTS
@@ -146,7 +210,7 @@
 		/* [unique][in] */ punk As IUnknown) As HRESULT
 	Function ReleaseBoundObjects() As HRESULT
-  	/* [local] */ Function SetBindOptions(
+	/* [local] */ Function SetBindOptions(
 		/* [in] */ ByRef bindopts As BIND_OPTS) As HRESULT
-  	/* [local] */ Function GetBindOptions(
+	/* [local] */ Function GetBindOptions(
 		/* [out][in] */ ByRef bindopts As BIND_OPTS) As HRESULT
 	Function GetRunningObjectTable(
@@ -159,13 +223,53 @@
 		/* [out] */ ByRef unk As IUnknown) As HRESULT
 	Function EnumObjectParam(
- 		/* [out] */ ByRef enumstr As IEnumString) As HRESULT
+		/* [out] */ ByRef enumstr As IEnumString) As HRESULT
 	Function RevokeObjectParam(
 		/* [in] */ pszKey As LPOLESTR) As HRESULT
 End Interface
 
-' IEnumMoniker
-
+/* interface IEnumMoniker */
+/* [unique][uuid][object] */
+
+Dim IID_IEnumMoniker = [&h00000102, 0, 0, [&hC0, 0, 0, 0, 0, 0, 0, &h46]] As IID
+Interface IEnumMoniker
+	Inherits IUnknown
+	/* [local] */ Function Next_(
+		/* [in] */ celt As DWord,
+		/* [length_is][size_is][out] */ rgelt As *IMoniker,
+		/* [out] */ ByRef celtFetched As DWord) As HRESULT
+	Function Skip(
+		/* [in] */ celt As DWord) As HRESULT
+	Function Reset() As HRESULT
+	Function Clone(
+		/* [out] */ enumMon As IEnumMoniker) As HRESULT
+End Interface
+
+/* interface IRunningObjectTable */
+/* [uuid][object] */
+
+Dim IID_IRunningObjectTable = [&h00000010, 0, 0, [&hC0, 0, 0, 0, 0, 0, 0, &h46]] As IID
 Interface IRunningObjectTable
 	Inherits IUnknown
+
+	Function Register(
+		/* [in] */ grfFlags As DWord,
+		/* [unique][in] */ unkObject As IUnknown,
+		/* [unique][in] */ mkObjectName As IMoniker,
+		/* [out] */ ByRef dwRegister As DWord) As HRESULT
+	Function Revoke(
+		/* [in] */ dwRegister As DWord) As HRESULT
+	Function IsRunning(
+		/* [unique][in] */ mkObjectName As IMoniker) As HRESULT
+	Function GetObject(
+		/* [unique][in] */ mkObjectName As IMoniker,
+		/* [out] */ ByRef unkObject As IUnknown) As HRESULT
+	Function NoteChangeTime(
+		/* [in] */ dwRegister As DWord,
+		/* [in] */ ByRef filetime As FILETIME) As HRESULT
+	Function GetTimeOfLastChange(
+		/* [unique][in] */ mkObjectName As IMoniker,
+		/* [in] */ ByRef filetime As FILETIME) As HRESULT
+	Function EnumRunning(
+		/* [out] */ ByRef enumMoniker As IEnumMoniker) As HRESULT
 End Interface
 
@@ -186,16 +290,96 @@
 	Function Load(
 		/* [unique][in] */ Stm As IStream) As HRESULT
-
 	Function Save(
 		/* [unique][in] */ Stm As IStream,
 		/* [in] */ fClearDirty As BOOL) As HRESULT
-
 	Function GetSizeMax(
 		/* [out] */ ByRef cbSize As ULARGE_INTEGER) As HRESULT
 End Interface
 
+/* interface IMoniker */
+/* [unique][uuid][object] */
+
+Const Enum MKSYS
+	MKSYS_NONE = 0
+	MKSYS_GENERICCOMPOSITE = 1
+	MKSYS_FILEMONIKER = 2
+	MKSYS_ANTIMONIKER = 3
+	MKSYS_ITEMMONIKER = 4
+	MKSYS_POINTERMONIKER = 5
+	MKSYS_CLASSMONIKER = 7
+	MKSYS_OBJREFMONIKER = 8
+	MKSYS_SESSIONMONIKER = 9
+	MKSYS_LUAMONIKER = 10
+End Enum
+
+/* [v1_enum] */ Const Enum MKREDUCE
+	MKRREDUCE_ONE = (3 << 16)
+	MKRREDUCE_TOUSER = (2 << 16)
+	MKRREDUCE_THROUGHUSER = (1 << 16)
+	MKRREDUCE_ALL = 0
+End Enum
+
+Dim IID_IMoniker = [&h0000000f, 0, 0, [&hC0, 0, 0, 0, 0, 0, 0, &h46]] As IID
 Interface IMoniker
 	Inherits IPersistStream
-End Interface
+
+	/* [local] */ Function BindToObject(
+		/* [unique][in] */ bc As IBindCtx,
+		/* [unique][in] */ mkToLeft As IMoniker,
+		/* [in] */ ByRef riidResult As IID,
+		/* [iid_is][out] */ ByRef Result As Any) As HRESULT
+	/* [local] */ Function BindToStorage(
+		/* [unique][in] */ bc As IBindCtx,
+		/* [unique][in] */ mkToLeft As IMoniker,
+		/* [in] */ ByRef riid As IID,
+		/* [iid_is][out] */ ByRef Obj As Any) As HRESULT
+	Function Reduce(
+		/* [unique][in] */ bc As IBindCtx,
+		/* [in] */ dwReduceHowFar As DWord,
+		/* [unique][out][in] */ ByRef mkToLeft As IMoniker,
+		/* [out] */ ByRef mkReduced As IMoniker) As HRESULT
+	Function ComposeWith(
+		/* [unique][in] */ ByRef mkRight As IMoniker,
+		/* [in] */ fOnlyIfNotGeneric As BOOL,
+		/* [out] */ ByRef mkComposite As IMoniker) As HRESULT
+	Function Enum_(
+		/* [in] */ fForward As BOOL,
+		/* [out] */ ByRef enumMoniker As IEnumMoniker) As HRESULT
+	Function IsEqual(
+		/* [unique][in] */ mkOtherMoniker As IMoniker) As HRESULT
+	Function Hash(
+		/* [out] */ ByRef dwHash As DWord) As HRESULT
+	Function IsRunning(
+		/* [unique][in] */ bc As IBindCtx,
+		/* [unique][in] */ mkToLeft As IMoniker,
+		/* [unique][in] */ mkNewlyRunning As IMoniker) As HRESULT
+	Function GetTimeOfLastChange(
+		/* [unique][in] */ bc As IBindCtx,
+		/* [unique][in] */ mkToLeft As IMoniker,
+		/* [out] */ ByRef FileTime As FILETIME) As HRESULT
+	Function Inverse(
+		/* [out] */ ByRef mk As IMoniker) As HRESULT
+	Function CommonPrefixWith(
+		/* [unique][in] */ mkOther As IMoniker,
+		/* [out] */ ByRef mkPrefix As IMoniker) As HRESULT
+	Function RelativePathTo(
+		/* [unique][in] */ mkOther As IMoniker,
+		/* [out] */ ByRef mkRelPath As IMoniker) As HRESULT
+	Function GetDisplayName(
+		/* [unique][in] */ bc As IBindCtx,
+		/* [unique][in] */ mkToLeft As IMoniker,
+		/* [out] */ ByRef pszDisplayName As LPOLESTR) As HRESULT
+	Function ParseDisplayName(
+		/* [unique][in] */ bc As IBindCtx,
+		/* [unique][in] */ mkToLeft As IMoniker,
+		/* [in] */  pszDisplayName As LPOLESTR,
+		/* [out] */ ByRef chEaten As DWord,
+		/* [out] */ ByRef mkOut As IMoniker) As HRESULT
+	Function IsSystemMoniker(
+		/* [out] */ ByRef dwMksys As DWord) As HRESULT
+End Interface
+
+/* interface IEnumString */
+/* [unique][uuid][object] */
 
 Dim IID_IEnumString = [&h00000101, 0, 0, [&hC0, 0, 0, 0, 0, 0, 0, &h46]] As IID
@@ -214,11 +398,23 @@
 End Interface
 
+/* interface ISequentialStream */
+/* [unique][uuid][object] */
+
 Dim IID_ISequentialStream = [&h0c733a30, &h2a1c, &h11ce, [&had, &he5, &h00, &haa, &h00, &h44, &h77, &h3d]] As IID
 Interface ISequentialStream
 	Inherits IUnknown
 
-	Function Read(pv As VoidPtr, cb As DWord, ByRef cbRead As DWord) As HRESULT
-	Function Write(pv As VoidPtr, cb As DWord, ByRef cbWritten As DWord) As HRESULT
-End Interface
+	Function Read(
+		/* [length_is][size_is][out] */ pv As VoidPtr,
+		/* [in] */ cb As DWord,
+		/* [out] */ ByRef cbRead As DWord) As HRESULT
+	Function Write(
+		/* [size_is][in] */ pv As VoidPtr,
+		/* [in] */ cb As DWord,
+		/* [out] */ ByRef cbWritten As DWord) As HRESULT
+End Interface
+
+/* interface IStream */
+/* [unique][uuid][object] */
 
 Type STATSTG
@@ -259,22 +455,52 @@
 	Inherits ISequentialStream
 
-	Function Seek(dlibMove As LARGE_INTEGER, dwOrigin As DWord, plibNewPosition As *ULARGE_INTEGER) As HRESULT
-	Function SetSize(libNewSize As ULARGE_INTEGER) As HRESULT
-	Function CopyTo(pstm As *IStream, cb As ULARGE_INTEGER, pcbRead As *ULARGE_INTEGER, pcbWritten As *ULARGE_INTEGER) As HRESULT
-	Function Commit(grfCommitFlags As DWord) As HRESULT
+	/* [local] */ Function Seek(
+		/* [in] */ dlibMove As LARGE_INTEGER,
+		/* [in] */ dwOrigin As DWord,
+		/* [out] */ plibNewPosition As *ULARGE_INTEGER) As HRESULT
+	Function SetSize(
+		/* [in] */ libNewSize As ULARGE_INTEGER) As HRESULT
+	/* [local] */ Function CopyTo(
+		/* [unique][in] */ stm As IStream,
+		/* [in] */ cb As ULARGE_INTEGER,
+		/* [out] */ pcbRead As *ULARGE_INTEGER,
+		/* [out] */ pcbWritten As *ULARGE_INTEGER) As HRESULT
+	Function Commit(
+		/* [in] */ grfCommitFlags As DWord) As HRESULT
 	Function Revert() As HRESULT
-	Function LockRegion(libOffset As ULARGE_INTEGER, cb As ULARGE_INTEGER, dwLockType As DWord) As HRESULT
-	Function UnlockRegion(libOffset As ULARGE_INTEGER, cb As ULARGE_INTEGER, dwLockType As DWord) As HRESULT
-	Function Stat(pstatstg As *STATSTG, grfStatFlag As DWord) As HRESULT
-	Function Clone(ByRef stm As IStream) As HRESULT
-End Interface
+	Function LockRegion(
+		/* [in] */ libOffset As ULARGE_INTEGER,
+		/* [in] */ cb As ULARGE_INTEGER,
+		/* [in] */ dwLockType As DWord) As HRESULT
+	Function UnlockRegion(
+		/* [in] */ libOffset As ULARGE_INTEGER,
+		/* [in] */ cb As ULARGE_INTEGER,
+		/* [in] */ dwLockType As DWord) As HRESULT
+	Function Stat(
+		/* [out] */ pstatstg As *STATSTG,
+		/* [in] */ grfStatFlag As DWord) As HRESULT
+	Function Clone(
+		/* [out] */ ByRef stm As IStream) As HRESULT
+End Interface
+
 TypeDef LPSTREAM = *IStream
 
+/* interface IEnumSTATSTG */
+/* [unique][uuid][object] */
+
+Dim IID_IEnumSTATSTG = [&h0000000d, 0, 0, [&hC0, 0, 0, 0, 0, 0, 0, &h46]] As IID
 Interface IEnumSTATSTG
 	Inherits IUnknown
-End Interface
-
-#ifndef __IStorage_INTERFACE_DEFINED__
-#define __IStorage_INTERFACE_DEFINED__
+
+	/* [local] */ Function Next_(
+		/* [in] */ celt As DWord,
+		/* [length_is][size_is][out] */ rgelt As *STATSTG,
+		/* [out] */ ByRef celtFetched As DWord) As HRESULT
+	Function Skip(
+		/* [in] */ celt As DWord) As HRESULT
+	Function Reset() As HRESULT
+	Function Clone(
+		/* [out] */ ByRef enumStat As IEnumSTATSTG) As HRESULT
+End Interface
 
 /* interface IStorage */
@@ -294,5 +520,4 @@
 
 Dim IID_IStorage = [&h0000000b, &h0000, &h0000, [&hC0, &h00, &h00, &h00, &h00, &h00, &h00, &h46]] As IID
-
 Interface IStorage
 	Inherits IUnknown
@@ -361,6 +586,8 @@
 End Interface
 
-#endif 	/* __IStorage_INTERFACE_DEFINED__ */
-
+/* interface IPersistFile */
+/* [unique][uuid][object] */
+
+Dim IID_IPersistFile = [&h0000010b, 0, 0, [&hC0, 0, 0, 0, 0, 0, 0, &h46]] As IID
 Interface IPersistFile
 	Inherits IPersist
@@ -379,9 +606,55 @@
 End Interface
 
-
-' IPersistStrage
-
+/* interface IPersistStorage */
+/* [unique][uuid][object] */
+
+Dim IID_IPersistStorage = [&h0000010a, 0, 0, [&hC0, 0, 0, 0, 0, 0, 0, &h46]] As IID
+Interface IPersistStorage
+	Inherits IPersist
+
+	Function IsDirty() As HRESULT
+	Function InitNew(
+		/* [unique][in] */ Stg As IStorage) As HRESULT
+	Function Load(
+		/* [unique][in] */ Stg As IStorage) As HRESULT
+	Function Save(
+		/* [unique][in] */ StgSave As IStorage,
+		/* [in] */ fSameAsLoad As BOOL) As HRESULT
+	Function SaveCompleted(
+		/* [unique][in] */ StgNew As IStorage) As HRESULT
+	Function HandsOffStorage() As HRESULT
+End Interface
+
+/* interface ILockBytes */
+/* [unique][uuid][object] */
+
+Dim IID_ILockBytes = [&h0000000a, 0, 0, [&hC0, 0, 0, 0, 0, 0, 0, &h46]] As IID
 Interface ILockBytes
 	Inherits IUnknown
+
+	/* [local] */ Function ReadAt(
+		/* [in] */ ulOffset As ULARGE_INTEGER,
+		/* [length_is][size_is][out] */ pv As VoidPtr,
+		/* [in] */ cb As DWord,
+		/* [out] */ ByRef cbRead As DWord) As HRESULT
+	/* [local] */ Function WriteAt(
+		/* [in] */ ulOffset As ULARGE_INTEGER,
+		/* [size_is][in] */ pv As VoidPtr,
+		/* [in] */ cb As DWord,
+		/* [out] */ ByRef cbWritten As DWord) As HRESULT
+	Function Flush() As HRESULT
+	Function SetSize(
+	/* [in] */ cb As ULARGE_INTEGER) As HRESULT
+	Function LockRegion(
+		/* [in] */ libOffset As ULARGE_INTEGER,
+		/* [in] */ cb As ULARGE_INTEGER,
+		/* [in] */ dwLockType As DWord) As HRESULT
+	Function UnlockRegion(
+		/* [in] */ libOffset As ULARGE_INTEGER,
+		/* [in] */ cb As ULARGE_INTEGER,
+		/* [in] */ dwLockType As DWord) As HRESULT
+	Function Stat(
+		/* [out] */ ByRef statstg As STATSTG,
+		/* [in] */ grfStatFlag As DWord) As HRESULT
 End Interface
 
@@ -415,5 +688,17 @@
 End Interface
 
-' IRootStorage
+/* interface IRootStorage */
+/* [unique][uuid][object] */
+
+Dim IID_IRootStorage = [&h00000012, 0, 0, [&hC0, 0, 0, 0, 0, 0, 0, &h46]] As IID
+Interface IRootStorage
+	Inherits IUnknown
+
+	Function SwitchToFile(
+		/* [in] */ pszFile As LPOLESTR) As HRESULT
+End Interface
+
+/* interface IAdviseSink */
+/* [unique][async_uuid][uuid][object] */
 
 Enum /*[transmit_as(long)]*/ TYMED
@@ -428,5 +713,14 @@
 End Enum
 
-Type STGMEDIUM
+Type RemSTGMEDIUM
+	tymed As DWord
+	dwHandleType As DWord
+	pData As DWord
+	pUnkForRelease As DWord
+	cbData As DWord
+	data[ELM(1)] As Byte
+End Type
+
+/* [wire_marshal] */ Type STGMEDIUM
 	tymed As DWord
 	data As VoidPtr
@@ -445,6 +739,60 @@
 End Type
 
+Type GDI_OBJECT
+'	ObjectType As DWord
+'	/* [switch_type] */ u As Union
+'		hBitmap As wireHBITMAP
+'		hPalette As wireHPALETTE
+'		hGeneric As wireHGLOBAL
+'	End Union
+End Type
+
+Type userSTGMEDIUM
+'	tymed As DWord
+'	/* [switch_type] */ u As Union
+'		/* Empty union arm */
+'		hMetaFilePict As wireHMETAFILEPICT
+'		hHEnhMetaFile As wireHENHMETAFILE
+'		hGdiHandle As *GDI_OBJECT
+'		hGlobal As wireHGLOBAL
+'		lpszFileName As LPOLESTR
+'		pstm As *BYTE_BLOB
+'		pstg As BYTE_BLOB
+'	End Union
+'	pUnkForRelease As IUnknown
+End Type
+
+TypeDef wireSTGMEDIUM = /* [unique] */ *userSTGMEDIUM
+TypeDef ASYNC_STGMEDIUM = /* [unique] */ *userSTGMEDIUM
+TypeDef wireSTGMEDIUM = /* [wire_marshal] */ STGMEDIUM
+
+Type userFLAG_STGMEDIUM
+'	ContextFlags As Long
+'	fPassOwnership As Long
+'	Stgmed As userSTGMEDIUM
+End Type
+
+TypeDef wireFLAG_STGMEDIUM = /* [unique] */ *userFLAG_STGMEDIUM
+
+Type /* [wire_marshal] */ FLAG_STGMEDIUM
+	ContextFlags As Long
+	fPassOwnership As Long
+	Stgmed As STGMEDIUM
+End Type
+
+Dim IID_IAdviseSink = [&h0000010f, 0, 0, [&hC0, 0, 0, 0, 0, 0, 0, &h46]] As IID
 Interface IAdviseSink
 	Inherits IUnknown
+
+	/* [local] */ Sub OnDataChange(
+		/* [unique][in] */ ByRef Formatetc As FORMATETC,
+		/* [unique][in] */ ByRef Stgmed As STGMEDIUM)
+	/* [local] */ Sub OnViewChange(
+		/* [in] */ dwAspect As DWord,
+		/* [in] */ lindex As Long)
+	/* [local] */ Sub OnRename(
+		/* [in] */ mk As IMoniker)
+	/* [local] */ Sub OnSave()
+	/* [local] */ Sub OnClose()
 End Interface
 
@@ -455,4 +803,5 @@
 ' AsyncIAdviseSink2
 
+Dim IID_IDataObject = [&h0000010e, 0, 0, [&hC0, 0, 0, 0, 0, 0, 0, &h46]] As IID
 Interface IDataObject
 	Inherits IUnknown
@@ -524,5 +873,4 @@
 
 Dim IID_IMessageFilter = [&h00000016, &h0000, &h0000, [&hC0, &h00, &h00, &h00, &h00, &h00, &h00, &h46]] As IID
-
 Interface IMessageFilter
 	Inherits IUnknown
@@ -533,10 +881,8 @@
 		/* [in] */ dwTickCount As DWord,
 		/* [in] */ lpInterfaceInfo As LPINTERFACEINFO) As DWord
-
 	Function RetryRejectedCall(
 		/* [in] */ htaskCallee As HTASK,
 		/* [in] */ dwTickCount As DWord,
 		/* [in] */ dwRejectType As DWord) As DWord
-
 	Function MessagePending(
 		/* [in] */ htaskCallee As HTASK,
@@ -653,3 +999,3 @@
 ' IInitializeSpy
 
-#endif'_INC_OBJIDL
+#endif '_INC_OBJIDL