Index: trunk/abdev/BasicCompiler32/Compile_ProcOp.cpp
===================================================================
--- trunk/abdev/BasicCompiler32/Compile_ProcOp.cpp	(revision 308)
+++ trunk/abdev/BasicCompiler32/Compile_ProcOp.cpp	(revision 316)
@@ -264,5 +264,6 @@
 }
 
-void _compile_proc(const UserProc *pUserProc){
+void _compile_proc(const UserProc *pUserProc)
+{
 	extern char *basbuf;
 	extern HANDLE hHeap;
@@ -786,88 +787,2 @@
 	//ローカル変数のネーム情報は後に解放する
 }
-
-void CompileBufferInProcedure( const UserProc &userProc ){
-	if( userProc.IsCompiled() ) return;
-
-	_compile_proc( &userProc );
-
-/*
-	// ログを履く
-	char temporary[8192];
-	temporary[0]=0;
-	lstrcat( temporary, "------------------------------------------------------------------\n" );
-	sprintf( temporary + lstrlen(temporary), "【 %s のコード情報】\n", userProc.GetFullName().c_str() );
-	sprintf( temporary + lstrlen(temporary), "code size: %d bytes\n", userProc.GetCodeSize() );
-	lstrcat( temporary, "------------------------------------------------------------------\n" );
-	lstrcat( temporary, "\n" );
-	Smoothie::Logger::Put( temporary );*/
-}
-void CompileLocal(){
-	if( compiler.IsDll() )
-	{
-		//DLLの場合はグローバル変数を初期化するための関数を一番初めにコンパイルする
-		const UserProc *pUserProc=GetSubHash("_System_InitDllGlobalVariables");
-		if(pUserProc){
-			CompileBufferInProcedure( *pUserProc );
-		}
-		else SetError(300,NULL,cp);
-	}
-	else
-	{
-		// グローバル領域を一番初めにコンパイルする
-		extern const UserProc *pSub_System_GlobalArea;
-		CompileBufferInProcedure( *pSub_System_GlobalArea );
-	}
-
-	//_System_TypeBase_InitializeUserTypesは一番最後にコンパイル
-	extern const UserProc *pSubStaticMethod_System_TypeBase_InitializeUserTypes;
-	pSubStaticMethod_System_TypeBase_InitializeUserTypes->CompleteCompile();
-
-	//_System_InitStaticLocalVariablesは一番最後にコンパイル
-	//※一般関数内の静的変数オブジェクトをすべて収集しなければならない
-	extern const UserProc *pSub_System_InitStaticLocalVariables;
-	pSub_System_InitStaticLocalVariables->CompleteCompile();
-
-	//_System_Call_Destructor_of_GlobalObjectは一番最後にコンパイル
-	extern const UserProc *pSub_System_Call_Destructor_of_GlobalObject;
-	pSub_System_Call_Destructor_of_GlobalObject->CompleteCompile();
-
-repeat:
-	compiler.GetObjectModule().meta.GetUserProcs().Iterator_Reset();
-	while( compiler.GetObjectModule().meta.GetUserProcs().Iterator_HasNext() )
-	{
-		UserProc *pUserProc = compiler.GetObjectModule().meta.GetUserProcs().Iterator_GetNext();
-		CompileBufferInProcedure( *pUserProc );
-	}
-
-	if( IsNeedProcCompile() ){
-		//プロシージャコンパイルによって、プロシージャコンパイルが必要になる場合
-		goto repeat;
-	}
-
-	if( !compiler.IsStaticLibrary() )
-	{
-		//_System_TypeBase_InitializeUserTypesは最後のほうでコンパイル
-		pSubStaticMethod_System_TypeBase_InitializeUserTypes->KillCompileStatus();
-		CompileBufferInProcedure( *pSubStaticMethod_System_TypeBase_InitializeUserTypes );
-
-		if( IsNeedProcCompile() ){
-			//プロシージャコンパイルによって、プロシージャコンパイルが必要になる場合
-
-			compiler.GetObjectModule().meta.GetUserProcs().Iterator_Reset();
-			while( compiler.GetObjectModule().meta.GetUserProcs().Iterator_HasNext() )
-			{
-				UserProc *pUserProc = compiler.GetObjectModule().meta.GetUserProcs().Iterator_GetNext();
-				CompileBufferInProcedure( *pUserProc );
-			}
-		}
-
-		//_System_InitStaticLocalVariablesは一番最後にコンパイル
-		pSub_System_InitStaticLocalVariables->KillCompileStatus();
-		CompileBufferInProcedure( *pSub_System_InitStaticLocalVariables );
-
-		//_System_Call_Destructor_of_GlobalObjectは一番最後にコンパイル
-		pSub_System_Call_Destructor_of_GlobalObject->KillCompileStatus();
-		CompileBufferInProcedure( *pSub_System_Call_Destructor_of_GlobalObject );
-	}
-}